package list;

import student.TestCase;

public class LinkedListTest extends TestCase {

	private LinkedList<String> emptyList;
	private LinkedList<String> pets;
	private LinkedList<String> tech;

	/**
	 * Set up lists"
	 */
	public void setUp() {
		emptyList = new LinkedList<>();
		pets = new LinkedList<>();
		tech = new LinkedList<>();
		tech.add("phone");
		tech.add("laptop");
		tech.add("monitor");
		tech.add("airbuds");
		tech.add("tablet");

	}

	/**
	 * should add new entries to the end of the list
	 */
	public void testAdd() {
		pets.add("dog");
		assertEquals(pets.getLength(), 1);
		pets.add("chicken");
		assertEquals(pets.getLength(), 2);
		pets.add("cat");
		pets.add("bunny");
		assertEquals(pets.getEntry(0), "dog");
		assertEquals(pets.getEntry(1), "chicken");
		assertEquals(pets.getEntry(2), "cat");
		assertEquals(pets.getEntry(3), "bunny");
	}

	public void testAddPosition() {
		pets.add(0, "hamster");
		assertEquals(pets.getEntry(0), "hamster");

		Exception thrown = null;
		try {
			pets.add(2, "ferret");
		} catch (Exception exception) {
			thrown = exception;
		}
		// checks that an exception was actually thrown
		assertNotNull(thrown);

		tech.add(5, "gaming console");
		assertEquals(tech.getLength(), 6);
		assertEquals(tech.getEntry(5), "gaming console");

		tech.add(2, "smartwatch");
		assertEquals(tech.getLength(), 7);
		assertEquals(tech.getEntry(0), "phone");
		assertEquals(tech.getEntry(1), "laptop");
		assertEquals(tech.getEntry(2), "smartwatch");
		assertEquals(tech.getEntry(3), "monitor");
		assertEquals(tech.getEntry(4), "airbuds");
		assertEquals(tech.getEntry(5), "tablet");
		assertEquals(tech.getEntry(6), "gaming console");
	}

	public void testRemove() {
		tech.remove(0);
		assertEquals(tech.getLength(), 4);
		assertEquals(tech.getEntry(0), "laptop");
		tech.remove(3);
		assertEquals(tech.getLength(), 3);
		assertEquals(tech.getEntry(2), "airbuds");
		tech.add("smartwatch");
		tech.add("gaming console");
		assertEquals(tech.getLength(), 5);
		assertEquals(tech.remove(2), "airbuds");
		assertEquals(tech.getLength(), 4);

		Exception thrown = null;
		try {
			emptyList.remove(2);
		} catch (Exception exception) {
			thrown = exception;
		}
		// checks that an exception was actually thrown
		assertNotNull(thrown);
		
		Exception thrown2 = null;
		try {
			tech.remove(4);
		} catch (Exception exception) {
			thrown2 = exception;
		}
		// checks that an exception was actually thrown
		assertNotNull(thrown2);

	}

	public void testReplace() {
//		tech.add("phone");
//		tech.add("laptop");
//		tech.add("monitor");
//		tech.add("airbuds");
//		tech.add("tablet");
		assertEquals(tech.replace(4, "iPad"), "tablet");
		assertEquals(tech.getLength(), 5);
		assertEquals(tech.getEntry(4), "iPad");

		assertEquals(tech.replace(0, "smartwatch"), "phone");
		assertEquals(tech.getLength(), 5);
		assertEquals(tech.getEntry(0), "smartwatch");

		assertEquals(tech.replace(2, "desktop"), "monitor");
		assertEquals(tech.getLength(), 5);
		assertEquals(tech.getEntry(2), "desktop");

		// could use toArray here for testing too

		Exception thrown = null;
		try {
			tech.replace(7, "drone");
		} catch (Exception exception) {
			thrown = exception;
		}
		// checks that an exception was actually thrown
		assertNotNull(thrown);

		Exception thrown2 = null;
		try {
			tech.replace(5, "drone");
		} catch (Exception exception) {
			thrown2 = exception;
		}
		// checks that an exception was actually thrown
		assertNotNull(thrown2);

	}

}
